using System;
using Avalonia.OpenGL;
using OpenTK;
using OpenTK.Graphics;
using OpenTK.Graphics.OpenGL;

namespace GLTFViewer.Rendering;

public class Renderer
{
    public void Initialize(GlInterface gl)
    {
        GLLoader.LoadBindings(new AvaloniaBindingsContext(gl));
        GL.ClearColor(1,1,1,1);
    }
    
    public void Render(GlInterface gl, int width, int height, int fbo)
    {
        GL.Viewport(0, 0, width, height);
        GL.Clear(ClearBufferMask.ColorBufferBit | ClearBufferMask.DepthBufferBit);
    }
    
    public void Deinitialize(GlInterface gl)
    {
        
    }
    
    private class AvaloniaBindingsContext : IBindingsContext
    {
        private readonly GlInterface _gl;

        public AvaloniaBindingsContext(GlInterface gl)
        {
            _gl = gl;
        }

        public IntPtr GetProcAddress(string procName)
        {
            return _gl.GetProcAddress(procName);
        }
    }
    
}