using System;
using Avalonia;
using Avalonia.Controls;
using Avalonia.Markup.Xaml;
using Avalonia.OpenGL;
using Avalonia.OpenGL.Controls;
using OpenTK;
using OpenTK.Graphics;
using OpenTK.Graphics.OpenGL;

namespace GLTFViewer;

public partial class BaseOpenTKControl : OpenGlControlBase
{
    
    // Events for the renderer to hook into
    public event Action<GlInterface> OnInit;
    public event Action<GlInterface> OnDeinit;
    public event Action<GlInterface, int, int, int> OnRender;
    
    public BaseOpenTKControl()
    {
        InitializeComponent();
    }

    protected override void OnOpenGlInit(GlInterface gl)
    {
        OnInit?.Invoke(gl);
    }

    protected override void OnOpenGlDeinit(GlInterface gl)
    {
        OnDeinit?.Invoke(gl);
    }

    protected override void OnOpenGlRender(GlInterface gl, int fbo)
    {
        var width = (int)Bounds.Width;
        var height = (int)Bounds.Height;
        OnRender?.Invoke(gl, width, height, fbo);
    }
}