using Avalonia;
using Avalonia.Controls;
using Avalonia.Controls.Templates;
using Avalonia.Markup.Xaml;

namespace GLTFViewer.Engine.Ui.Controls;

public partial class BasePropertyViewerControl : UserControl
{
    private TreeView _propertyTreeView;
    private TreeView _sceneTreeView;
    
    public BasePropertyViewerControl()
    {
        InitializeComponent();

        _propertyTreeView = PropertyTreeView;
    }

    public void Init(TreeView sceneTreeView)
    {
        _sceneTreeView = sceneTreeView;
        
        _sceneTreeView.SelectionChanged += (_, _) => UpdateProperties();
    }
    
    public void UpdateProperties()
    {
        _propertyTreeView.ItemsSource = _sceneTreeView.SelectedItem is Node node ? node.Properties : null;
        _propertyTreeView.ItemTemplate = new FuncTreeDataTemplate<NodeProperty>(
            (property, _) =>
            {
                var textBlock = new TextBlock { Text = property.Name };
                return textBlock;
            },
            property => null
        );
    }
}